/* This may look like c to you, but it's really -*-c++-*- */

/*   GMA or "The Go-moku Apprentice" is a go-moku implementation that learns
 *   the game from its own (and its opponents') mistakes.
 *   Copyright (C) 1998 Johan Walles (d92-jwa@nada.kth.se)
 *
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of the GNU General Public License as published by 
 *   the Free Software Foundation; either version 2 of the License, or 
 *   (at your option) any later version. 
 *
 *   This program is distributed in the hope that it will be useful, 
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef MOVES_H
#define MOVES_H

#include "pattern.h"

#include <stl.h>

class Moves:map<Pattern,int>
{
public:
  int &operator[](const Pattern pattern)
    { return map<Pattern,int>::operator[](pattern); }

  int lookup(const Pattern) const;
  
  void clear()
    { map<Pattern,int>::clear(); }
  
  Pattern findfirst();
  Pattern findnext();
  Pattern current();
  bool is_valid() const
    { return my_iterator != end(); }

  int count() const
    { return size(); }
  
protected:
  iterator my_iterator;
};

#endif // ifndef MOVES_H
