/* This may look like c to you, but it's really -*-c++-*- */

/*   GMA or "The Go-moku Apprentice" is a go-moku implementation that learns
 *   the game from its own (and its opponents') mistakes.
 *   Copyright (C) 1998 Johan Walles (d92-jwa@nada.kth.se)
 *
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of the GNU General Public License as published by 
 *   the Free Software Foundation; either version 2 of the License, or 
 *   (at your option) any later version. 
 *
 *   This program is distributed in the hope that it will be useful, 
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef SCORES_H
#define SCORES_H

#include <stl.h>
#include <string>
#include "pattern.h"

class Scores
{
public:
  typedef map<unsigned int, int> scoremap;

  int get_score(const Pattern pattern) const;
  void mark_good(const Pattern pattern, int goodness = 1);
  
  void clear() { lines.clear(); };

  unsigned int count() { return lines.size(); }

  bool init(const char *filename);
  bool dump(const char *filename);

protected:
  scoremap lines;
};

#endif  // ifndef SCORES_H

